#!/usr/local/bin/perl

use strict;

my(@pages) =
(
    [0,0,'/','Home'],
    [3,0,'/news/','News'],
    [2,0,'/products/','Products'],
    [2,1,'/products/bargains/','Bargains'],
    [1,1,'/products/intova/','Intova'],
    [1,1,'/products/tektite/','Tektite'],
    [1,1,'/products/ulcs/','ULCS'],
    [1,1,'/products/order/','Order'],
    [1,0,'/science/','Science'],
    [1,1,'/science/technology/','Technology'],
    [1,1,'/science/excitationfilters/','Excitation Filters'],
    [1,1,'/science/barrierfilters/','Barrier Filters'],
    [1,1,'/science/spectrographs/','Spectrographs'],
    [1,0,'/gallery/','Gallery'],
    [0,1,'/gallery/photos/','Photos'],
    [0,1,'/gallery/videos/','Videos'],
    [1,0,'/links/','Links'],
    [1,0,'/about/','About'],
    [0,0,'/publications/','Publications'],
    [0,1,'/publications/deutsch/','Deutsch'],
    [4,2,'/publications/deutsch/einfuehrung/','Im Trend: Fluoreszenz-Nachttauchg&auml;nge'],
    [4,2,'/publications/deutsch/biologie/','Biologie der Unterwasser-Fluoreszenz'],
    [0,1,'/publications/english/','English'],
    [4,2,'/publications/english/introduction/','On The Rise: Fluorescence Night Dives'],
    [0,2,'http://translate.google.com/translate?sl=de&tl=en&prev=_t&hl=en&ie=UTF-8&u=http://www.firedivegear.com/publications/deutsch/biologie/','The Biology of Underwater Fluorescence'],
    [0,0,'/sitemap/','Sitemap'],
);

# Flags:
#
# 0 = no scanning at all
# 1 = scan for "name" tags in index.shtml file (normal)
# 2 = scan for "name" tags in index.shtml file, observe indentation
# 3 = scan for "name" tags in index.shtml file, except for dates
# 4 = scan for "name" tags in index.html file

my $margin = 80;

my($item,$flag,$rank,$link,$name,$tabs,$matched,$prev,$next,$file,$text,$tag,$lbl,$jump);

my(@date) = (localtime())[5,4,3];
$date[0] += 1900;
$date[1]++;
my $date = sprintf("%04d/%02d/%02d", @date);

print <<"VERBATIM";
Content-type: text/html; charset="iso-8859-1"

<!DOCTYPE html>
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
<meta http-equiv="expires" content="0">
<meta name="distribution" content="global">
<meta name="revised" content="${date}">
<meta name="language" content="English">
<meta http-equiv="content-style-type" content="text/css">
<meta http-equiv="content-script-type" content="text/javascript">
<meta name="author" content="Lynn M. Miner, Steffen O. Beyer">
<meta name="owner" content="Lynn M. Miner, Steffen O. Beyer">
<meta name="description" content="FireDiveGear.com provides high quality gear / underwater equipment for fluorescence diving for the small budget, custom equipment made to measure, and lots of scientific and practical background information.">
<meta name="keywords" content="uv night dive, uv dive light, uv torch, uv lamp, uv flashlight, black light, fluo night dive, fluo dive light, uv dive, glow dive, fluo diving, fluo dive, fluoro dive, fluorescence night dive, fluorescent night dive, fluorescence dive light, dive equipment, dive gear, scuba dive gear, scuba dive equipment, uv filter, blue filter, yellow filter, dichroic filter, barrier filter, excitation filter, interference filter, mask filter, camera filter, uv video light, blue video light, uv light strobe, blue light strobe, black light strobe, dive lamp, dive light, dive torch, dive flashlight, underwater lamp, underwater light, underwater torch, underwater flashlight, underwater uv light, underwater uv torch, underwater uv lamp, underwater uv flashlight, blue light, blue lamp, blue torch, blue flashlight, blue dive light, blue dive torch, blue dive lamp, blue dive flashlight, intova, ulcs, tektite, tek-tite">
<link rel="stylesheet" type="text/css" href="/css/firedivegear.css">
<title>FireDiveGear.com: Sitemap</title>
</head>
<body bgcolor="#000000">
<center>

<table width="100%" cellpadding="0" cellspacing="0" border="0">

<tr>
    <td align="left" valign="middle" width="128" height="96"><a class="img-link" href="/sitemap/"><img width="128" height="29" src="/img/Logo.png" alt="[Sitemap]" border="0"></a></td>
    <td colspan="3" align="center" valign="middle" width="800" height="96" style="max-width:800px;"><h1>Sitemap</h1></td>
    <td align="center" valign="middle" width="128" height="96"><a class="img-link" href="/sitemap/"><img width="128" height="96" src="/img/Sitemap.png" alt="[Sitemap]" border="0"></a></td>
</tr>

<tr>
    <td align="left" valign="middle" width="128">&nbsp;</td>
    <td colspan="3" align="center" valign="middle" width="800" style="max-width:800px;">
        <table cellpadding="24" cellspacing="0" border="0">
        <tr>
        <td align="left" valign="top">
VERBATIM

ITEM:
for $item (@pages)
{
    ($flag,$rank,$link,$name) = @{$item};
    $tabs = $margin * $rank;
    print qq{            <p style="margin-left:${tabs}px"><a href="${link}">${name}</a></p>\n};
    if ($flag)
    {
        if ($flag == 4) { $file = '..' . $link . 'index.html';  }
        else            { $file = '..' . $link . 'index.shtml'; }
        local($/);
        if (open(FILE, "<$file") and ($text = <FILE>) and close(FILE))
        {
            SSI:
            while ($text =~ s{<!--#include\s+virtual="([^"]+)"\s*-->}{includefile($1)}egi) {}
            $matched = 0;
            MATCH:
            while ($text =~ m!<a\s+name="([^"]*)"[^<>]*>(.+?)</a>!gsi)
            {
                $tag = $1;
                $lbl = $2;
                unless ($matched)
                {
                    print qq{            <div style="margin-left:${tabs}px">\n};
                    print qq{            <ul>\n};
                }
                $matched = 1;
                $prev = $next = 0;
                if ($flag == 2)
                {
                    if ($lbl =~ s{<!--\s*-(\d)\s*-->}{})  { $prev = $1; }
                    if ($lbl =~ s{<!--\s*\+(\d)\s*-->}{}) { $next = $1; }
                }
                elsif ($flag == 3)
                {
                    next MATCH if ($tag =~ m!^\d+$!);
                }
                $tag =~ s!^\s+!!;
                $tag =~ s!\s+$!!;
                $lbl =~ s!</?[^<>]+>!!g;
                $lbl =~ s!^\s+!!;
                $lbl =~ s!\s*\(\d+\)\s*$!!;
                $lbl =~ s!:+\s*$!!;
                $lbl =~ s!\s+$!!;
                if ($name =~ m!\b(?:products|bargains)\b!i)
                {
                    if    ($tag =~ m!\breadme\b!i)    { $lbl = 'Read me first'; }
                    elsif ($tag =~ m!\bsandwich\b!i)  { $lbl = 'Sandwiched filters'; }
                    elsif ($tag =~ m!\bledlenser\b!i) { $lbl = 'Original LED Lenser D14 Dive Light'; }
                    elsif ($tag !~ m!\bhandle\b!i)    { $lbl = $1 if ($lbl =~ m!(&quot;.+&quot;)!); }
                }
                elsif ($name =~ m!\bscience\b!i)
                {
                    if ($tag =~ m!\bfluorescence\b!i) { $lbl = 'Fluorescence'; }
                }
                elsif ($name =~ m!\btechnology\b!i)
                {
                    if ($tag =~ m!\bfilters\b!i) { $lbl .= ' (more in-depth)'; }
                }
                elsif ($name =~ m!\bexcitation\s+filters\b!i)
                {
                    if    ($tag =~ m!\bcomparison\b!i)    { $lbl .= ' without and with dichroic filter'; }
                    elsif ($tag =~ m!\bspectrographs\b!i) { $lbl .= ' without and with dichroic filter'; }
                    elsif ($tag =~ m!\bwhitevsblue\b!i)   { $lbl  = 'Comparison white versus blue'; }
                    elsif ($tag =~ m!\bsandwich\b!i)      { $lbl  = 'Comparison sandwiched strobe filters'; }
                }
                elsif ($name =~ m!\blinks\b!i)
                {
                    if    ($tag =~ m!\bpublications\b!i) { $lbl  = 'List of publications of ours'; }
                    elsif ($tag =~ m!\btestimonials\b!i) { $lbl .= ' - what people say about fluo-diving'; }
                }
                elsif ($name =~ m!\babout\b!i)
                {
                    if ($tag =~ m!\btestimonials\b!i) { $lbl .= ' - what people say about FireDiveGear.com'; }
                }
                $jump = $link . '#' . $tag;
                while ($prev-- > 0)
                {
                    print qq{            </ul>\n};
                }
                print qq{                <li><a href="${jump}">${lbl}</a></li>\n} if ($tag ne '');
                while ($next-- > 0)
                {
                    print qq{            <ul>\n};
                }
            }
            if ($matched)
            {
                print qq{            </ul>\n};
                print qq{            </div>\n};
            }
        }
    }
}

print <<"VERBATIM";
            <p>Note: The bulleted links above are links to sections within the same page, whereas the non-bulleted links above are links to real pages</p>
        </td>
        </tr>
        </table>
    </td>
    <td align="center" valign="middle" width="128">&nbsp;</td>
</tr>

<tr>
    <td align="center" valign="middle" colspan="5">
        <p><a class="img-link" target="_blank" href="http://info.flagcounter.com/7XYU"><img src="http://s04.flagcounter.com/count/7XYU/bg_000000/txt_FFFFFF/border_000000/columns_3/maxflags_12/viewers_3/labels_1/pageviews_1/flags_1/" alt="[Flag Counter]" border="0"></a></p>
        <p><b>&copy; 2012-2013 FireDiveGear.com</b></p>
    </td>
</tr>

</table>

</center>
</body>
</html>
VERBATIM

sub includefile($)
{
    my $inc = '..' . shift;
    my $txt;
    local($/);
    if (open(INC, "<$inc") and ($txt = <INC>) and close(INC)) { return $txt; }
    else                                                      { return '';   }
}

__END__
